vgp.curve.closedpoly

## Class PjClosedPoly

- java.lang.Object
- - jv.object.PsObject
  - - jv.project.PjProject
    - - vgp.curve.closedpoly.PjClosedPoly

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsTimeListenerIf, PsUpdateIf, PvPickListenerIf

      public class PjClosedPoly
      extends PjProject

  Study closed polygonal curves under motion of selected vertices. Length of polygon edges is kept when vertices are dragged.
  See Also:
    Serialized Form
  Author:
    Eike Preuß
  Version:
    03.02.00, 1.00 created (ep)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `MODE_GLOBAL`
    `static int` | `MODE_LOCAL`
    `static int` | `MODE_MIRROR`

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PjClosedPoly()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `computeNGon(int numPoints, PgPolygon out)`
    `void` | `dragVertex(PgGeometryIf geom, int index, PdVector vertex)` Drag a picked vertex of a geometry.
    `boolean` | `getNearestSupplement(PdVector first, PdVector second, PdVector reference)`
    `PgPolygon` | `getPolygon()`
    `void` | `globalTransformation(int vertex, PdVector newPos, PgPolygon out)`
    `void` | `init()` Initialize and reset project, stops the running animation if any.
    `void` | `localTransformation(int vertex, PdVector newPos, PgPolygon out)`
    `void` | `mirrorVertex(int vertex, PgPolygon out)`
    `void` | `pickVertex(PgGeometryIf geom, int index, PdVector vertex)` Get a picked vertex of a geometry.
    `void` | `setMode(int mode)`
    `void` | `start()` Method is invoked during loading of a project in JavaView.
    `void` | `traktrix(PdVector p1, PdVector p2, PdVector v, PdVector out)`
    `boolean` | `traktrixAll(int vertex, PdVector newPos, PdVector[] vert, PdVector[] orig)`
    `boolean` | `update(java.lang.Object event)` Update the class whenever a child has changed.

    - ### Methods inherited from class jv.project.PjProject

      `addDisplay, addGeometry, addGeometry, dispose, dragDisplay, dragInitial, fitDisplays, getAnimation, getDisplay, getDisplays, getGeometry, getGeometry, getNumGeometries, getParameter, getParameterInfo, getViewer, hasAnimation, hasDisplay, isEnabledAutoFit, markVertices, pickDisplay, pickInitial, removeDisplay, removeGeometries, removeGeometry, selectDisplay, selectGeometry, setAnimation, setBackColor, setBorderType, setDisplay, setEnabledAutoFit, setGeometry, setParameterInfo, setTime, setViewer, stop, unmarkVertices`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.anim.PsTimeListenerIf

      `getName`

    - ### Methods inherited from interface jv.project.PvPickListenerIf

      `getName`

- - ### Field Detail

    - #### MODE_MIRROR

          public static final int MODE_MIRROR

      See Also:
        Constant Field Values

    - #### MODE_LOCAL

          public static final int MODE_LOCAL

      See Also:
        Constant Field Values

    - #### MODE_GLOBAL

          public static final int MODE_GLOBAL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PjClosedPoly

          public PjClosedPoly()

  - ### Method Detail

    - #### init

          public void init()

      Description copied from class: `PjProject`
      Initialize and reset project, stops the running animation if any. Does not reset any registered display nor geometry. They must be reset individually in each subclass.
      Overrides:
        `init` in class `PjProject`

    - #### start

          public void start()

      Description copied from class: `PjProject`
      Method is invoked during loading of a project in JavaView.

      If a project has an animation object, then the animation panel is shown when the project's this start() method is invoked during loading of the project. Use `setAnimation(PsAnimation)` to register an animation.

      If auto fit is enabled then scenery is scaled to fit in each display.

      Overrides:
        `start` in class `PjProject`
      See Also:
        `PvViewerIf.start()`, `PjProject.isEnabledAutoFit()`

    - #### update

          public boolean update(java.lang.Object event)

      Update the class whenever a child has changed. Method is usually invoked from the children.
      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PsObject`
      Parameters:
        `event` - carries a lot of information
      Returns:
        true if event has been handled, otherwise false
      See Also:
        `PsObject.setParent(PsUpdateIf)`, `PsObject.getFather()`, `PsObject.addUpdateListener(PsUpdateIf)`

    - #### computeNGon

          public void computeNGon(int numPoints,
                                  PgPolygon out)

    - #### mirrorVertex

          public void mirrorVertex(int vertex,
                                   PgPolygon out)

    - #### localTransformation

          public void localTransformation(int vertex,
                                          PdVector newPos,
                                          PgPolygon out)

    - #### getNearestSupplement

          public boolean getNearestSupplement(PdVector first,
                                              PdVector second,
                                              PdVector reference)

      Parameters:
        `reference` - input/output, here the calculated vector is saved

    - #### globalTransformation

          public void globalTransformation(int vertex,
                                           PdVector newPos,
                                           PgPolygon out)

    - #### traktrixAll

          public boolean traktrixAll(int vertex,
                                     PdVector newPos,
                                     PdVector[] vert,
                                     PdVector[] orig)

    - #### traktrix

          public void traktrix(PdVector p1,
                               PdVector p2,
                               PdVector v,
                               PdVector out)

      Parameters:
        `v` - acceleration vector of p1

    - #### pickVertex

          public void pickVertex(PgGeometryIf geom,
                                 int index,
                                 PdVector vertex)

      Description copied from class: `PjProject`
      Get a picked vertex of a geometry. This method does nothing and must be overwritten.
      Specified by:
        `pickVertex` in interface `PvPickListenerIf`
      Overrides:
        `pickVertex` in class `PjProject`
      Parameters:
        `geom` - Picked geometry on which vertex lies
        `index` - Index of vertex in vertex array of geometry
        `vertex` - 3d coordinates of vertex position
      See Also:
        `PvPickListenerIf`

    - #### dragVertex

          public void dragVertex(PgGeometryIf geom,
                                 int index,
                                 PdVector vertex)

      Description copied from class: `PjProject`
      Drag a picked vertex of a geometry. This method invokes `pickVertex(PgGeometryIf, int, PdVector)` and should be overwritten.
      Specified by:
        `dragVertex` in interface `PvPickListenerIf`
      Overrides:
        `dragVertex` in class `PjProject`
      Parameters:
        `geom` - Picked geometry on which vertex lies
        `index` - Index of vertex in vertex array of geometry
        `vertex` - 3d coordinates of vertex position
      See Also:
        `PvPickListenerIf`

    - #### setMode

          public void setMode(int mode)

    - #### getPolygon

          public PgPolygon getPolygon()

"

The software JavaView? is copyright protected. All Rights Reserved.
"